<?php

include_once($_SESSION['sys']['basedir'].'/lib/overview_utils.php');

if (empty($_SESSION['overview_stunden.year'])) $_SESSION['overview_stunden.year'] = 0;

$details = <<<EOC
<div style="padding-left: 3px; margin-top: -10px;">
<b>Gebiet</b>: <span id="detail_gebiet"></span><br>
<b>Gewässer</b>: <span id="detail_kostenstelle"></span><br>
<b>Länge</b>: <span id="detail_laenge"></span><br>
<b>Gesamtstunden</b>: <span id="detail_gewaesserstunden"></span><br>
<b>Personalstunden</b>: <span id="detail_personalstunden"></span><br>
<b>Gerätestunden</b>: <span id="detail_geraetestunden"></span><br>
<b>Gewässer gereinigt</b>: <span id="detail_gereinigt"></span>
</div>
EOC;

$mask = array(
	      'table' => 'einsatz',
	      'title' => 'Stundenübersicht nach Kostenstellen',
	      'join' => array(
			      'arbeitsarten ON einsatz.arbeiten = arbeitsarten.id',
			      'einsatzpersonal ON einsatzpersonal.einsatz = einsatz.id',
			      'LEFT einsatzgeraete ON einsatzgeraete.einsatz = einsatz.id',
			      'gebiet ON einsatz.gebiet = gebiet.id',
			      'kostenstellen ON einsatz.kostenstelle = kostenstellen.id',
			      'personal ON einsatzpersonal.personal = personal.id',
			      'LEFT gerate ON einsatzgeraete.geraet = gerate.id',
			      'LEFT anbaugeraete ON einsatzgeraete.anbaugeraet = anbaugeraete.id',
			      ),
	      'where' => "arbeitsarten.arbeitsart <> 'Urlaub' AND arbeitsarten.arbeitsart <> 'Krank' AND arbeitsarten.arbeitsart <> 'Sonstige Fehltage'"
		       . " AND date_part('year', datum) = " . $_SESSION['overview_stunden.year'],
	      'select' => array(
				'title' => 'Auswahl',
				'options' => discover_years(),
				'default' => 'Jahr wählen',
				'selected' => $_SESSION['overview_stunden.year'],
				'onchange' => "setvar(this,'year',select_year_calback,select_year_status)",
				),
	      'variables' => array(
				   'year' => array(),
				   ),
 	      'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'visible' => false,
					    'width' => 60,
					    'sql' => 'einsatz.id',
					    ),
			      'datum' => array(
					    'name' => 'Datum',
					    'type' => 'date',
					    'width' => 70,
					    ),
			      'gebiet' => array(
					    'name' => 'Gebiet',
					    'sql' => "gebiet.gebiet",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'kostenstelle' => array(
					    'name' => 'Kostenstelle',
					    'sql' => "kostenstellen.kostenstelle",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'arbeitsarten' => array(
					    'name' => 'Arbeiten',
					    'sql' => "arbeitsarten.arbeitsart",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'personal' => array(
					    'name' => 'Mitarbeiter',
					    'sql' => "personal.name || ', ' || personal.vorname",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'stunden' => array(
					    'name' => 'Mitarbeiterstunden',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 60,
					    'sql' => 'einsatzpersonal.stunden'
					    ),
			      'geraet' => array(
					    'name' => 'Gerät',
					    'sql' => "gerate.geraet",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'anbaugeraet' => array(
					    'name' => 'Anbaugerät',
					    'sql' => "anbaugeraete.anbaugeraet",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'geraetstunden' => array(
					    'name' => 'Gerätstunden',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 60,
					    'sql' => 'einsatzgeraete.stunden'
					    ),
			      'gesamtstunden' => array(
					    'name' => 'Gesamtstunden',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 60,
					    'sql' => 'einsatzpersonal.stunden + einsatzgeraete.stunden',
					    ),
			      ),
 	      'details' => array(
				 'html' => $details,
				 'list' => array(
						 'gebiet' => array('fetch' => fetch_gebiet),
						 'kostenstelle' => array('fetch' => fetch_kostenstelle),
						 'laenge' => array('fetch' => fetch_laenge),
						 'gewaesserstunden' => array('fetch' => fetch_gewaesserstunden),
						 'personalstunden' => array('fetch' => fetch_personalstunden),
						 'geraetestunden' => array('fetch' => fetch_geraetestunden),
						 'gereinigt' => array('fetch' => fetch_gereinigt),
						 ),

			      ),
	      );

function fetch_gebiet()
{
  $sql = 'SELECT gebiet.gebiet FROM gebiet JOIN einsatz ON einsatz.gebiet = gebiet.id WHERE einsatz.id = ' . intval($_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['gebiet'];
}

function fetch_kostenstelle()
{
  $sql = 'SELECT kostenstellen.kostenstelle FROM kostenstellen JOIN einsatz ON einsatz.kostenstelle = kostenstellen.id WHERE einsatz.id = ' . intval($_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['kostenstelle'];
}

function fetch_laenge()
{
  $sql = 'SELECT laenge FROM kostenstellen JOIN einsatz ON einsatz.kostenstelle = kostenstellen.id WHERE einsatz.id = ' . intval($_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['laenge'] . ' m';
}

function fetch_gewaesserstunden()
{
  $sql = <<<EOC
  SELECT sum(stunden) AS gesamt
  FROM einsatzpersonal
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_stunden.year'], $_POST['id']);
  $pstunden = query_db($sql);
  if ($pstunden === false) return '';

  $sql = <<<EOC
  SELECT sum(stunden) AS gesamt
  FROM einsatzgeraete
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_stunden.year'], $_POST['id']);
  $gstunden = query_db($sql);
  if ($gstunden === false) return '';

  return sprintf('%.2f', $pstunden[0]['gesamt'] + $gstunden[0]['gesamt']);
}

function fetch_personalstunden()
{
  $sql = <<<EOC
  SELECT sum(stunden) AS gesamt
  FROM einsatzpersonal
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_stunden.year'], $_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return sprintf('%.2f', $res[0]['gesamt']);
}

function fetch_geraetestunden()
{
  $sql = <<<EOC
  SELECT sum(stunden) AS gesamt
  FROM einsatzgeraete
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_stunden.year'], $_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return sprintf('%.2f', $res[0]['gesamt']);
}

function fetch_gereinigt()
{
  $sql = <<<EOC
  SELECT count(*) AS count
  FROM gereinigt
  JOIN kostenstellen ON gereinigt.kostenstelle = kostenstellen.id
  JOIN einsatz ON einsatz.kostenstelle = kostenstellen.id
  WHERE jahr = %d AND einsatz.id = %d
EOC;

  $sql = sprintf($sql, $_SESSION['overview_kosten.year'], $_POST['id']);

  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['count'] == 0 ? 'nein' : 'ja';
}

?>
